﻿----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Micâh - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------

local DF = DOF_namespace
local _

function DF:GetBleedAbilityDamageCoefficient(docActive, spell, spellId)
    
    local spellShowsStealth=false
    local spellShowsTigersFuror=false
    local spellShowsBloodtalons=false
    local powerFlags=0

    powerFlags = DF_powerId[tonumber(spellId)]
    if (powerFlags) then        
      spellShowsStealth = spellShowsStealth or DF:hasbit(powerFlags,DF:bit(3))
      spellShowsTigersFuror = spellShowsTigersFuror or DF:hasbit(powerFlags,DF:bit(1))
      spellShowsBloodtalons = spellShowsBloodtalons or DF:hasbit(powerFlags,DF:bit(2))
    end

    -- nouvelle formule, ne tiens compte que du rugissement, fureur du tigre et bloodtalons
    local damageCoeff=1

    --if DF:spell_exist(nil,DF.SavageRoarName,"player","HELPFUL|PLAYER",false) and spellShowsSavageRoar then  -- savage roar
    --	damageCoeff=damageCoeff*1.15
    --end
	
	-- tiger's fury
    if DF:spell_exist(nil,DF.TigerFuryName,"player","HELPFUL|PLAYER",false) and spellShowsTigersFuror then   -- tiger furor 
    	damageCoeff=damageCoeff*1.15
    end
	
	-- Bloodtalons has been redesigned – When you use 3 different combo point- generating abilities within 4 seconds, the damage of your next 2 Rips or Ferocious Bites is increased by 30%.
    if docActive and spellShowsBloodtalons and ((spell==DF.RipName) or (spell==DF.FerociousBite))then  -- bloodtalons damage boost 
      damageCoeff=damageCoeff*1.3
    end
	
	-- Rake deals 60% increased damage while stealthed
	-- Shred deals 60% increased damage while stealthed (was 30%).
	-- Berserk has been redesigned – Go berserk for 20 seconds, causing Rake and Shred to deal damage as though you were stealthed, and giving finishing moves a 20% chance per combo point spent to refund 1 combo point
	-- Incarnation: King of the Jungle now grants the benefits of Berserk, reduces the energy cost of all Cat Form abilities by 20%, and allows the use of Prowl once while in combat.
    if (spell==DF.RakeName) and (IsStealthed() or DF:spell_exist(nil,DF.IncarnationName,"player","HELPFUL|PLAYER",false)or DF:spell_exist(nil,DF.BerzerkName,"player","HELPFUL|PLAYER",false)or DF:spell_exist(nil,DF.SuddenAmbush,"player","HELPFUL|PLAYER",false)) then  -- rake when prowling or with incarnation
      damageCoeff=damageCoeff*1.60
    end
    if (spell==DF.ShredName) and (IsStealthed() or DF:spell_exist(nil,DF.IncarnationName,"player","HELPFUL|PLAYER",false)or DF:spell_exist(nil,DF.BerzerkName,"player","HELPFUL|PLAYER",false)) then  -- shred when prowling or with incarnation
      damageCoeff=damageCoeff*1.60
    end

    return damageCoeff
    
end

function DF:GetDotPower(spell,docActive,forceCP)
   
    local bleedCoeff
    local CP = UnitPower('player', 4)
    local dotPower=0
    local bleedBase
    
    if DF.dotPowerDatas[spell] then
	
			bleedCoeff = DF:GetBleedAbilityDamageCoefficient(docActive, spell, DF.dotPowerDatas[spell].spellId)
			
	    if forceCP then CP=forceCP end
	    if DF.dotPowerDatas[spell].basecp==0 then CP=1 end
	    
	    bleedBase = (DF.dotPowerDatas[spell].base
	                   +(DF.dotPowerDatas[spell].basecp * CP))
	                   +((DF.dotPowerDatas[spell].baseap * DF.playerAP) * CP)
	    
	    dotPower = bleedCoeff * bleedBase

	  end
	  
    return dotPower
    
end

function DF:GetAbiPower(spellid)
	local targetID=UnitGUID("playertarget")
	if targetID and DF.abiPowers[targetID] and DF.abiPowers[targetID][spellid] then
		return DF.abiPowers[targetID][spellid]
	else
		return nil
	end
end

